import {
  useChakra
} from "./chunk-JJPTUARU.mjs";
import {
  formElements
} from "./chunk-K4HJDA3E.mjs";
import {
  css,
  cx
} from "./chunk-U7VTKF2F.mjs";
import {
  domElements
} from "./chunk-EWHL3RPP.mjs";
import {
  __name
} from "./chunk-INDHDMU3.mjs";

// src/chakra.tsx
import { createVNode as _createVNode, isVNode as _isVNode, mergeProps as _mergeProps } from "vue";
import { computed, defineComponent, resolveComponent } from "vue";
import { css as css2, isStyleProp } from "@chakra-ui/styled-system";
import { isFunction, objectFilter, isObject, memoizedGet as get } from "@chakra-ui/utils";
import { extractStyleAttrs } from "@chakra-ui/vue-utils";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !_isVNode(s);
}
__name(_isSlot, "_isSlot");
var chakraProps = {
  as: [String, Object],
  __css: Object,
  sx: Object,
  css: Object,
  noOfLines: [String, Number, Object, Array],
  baseStyle: Object,
  isTruncated: Boolean,
  layerStyle: String,
  textStyle: String,
  apply: String,
  label: String,
  modelValue: [String, Number, Object, Array],
  /**
   * @warning
   * @internal
   * This internal is an internal ChakraFactoryFunction prop that
   * is used to determine how events are handled on Chakra Factory
   * components.
   *
   * For example, if a factory component is considered to be raw (i.e. `__chakraIsRaw: true`),
   * then, we do not pass v-model event listeners onto the component. This means that
   * `v-model` will not work in the template context.
   *
   * You can see how this prop is used in the `c-input` component.
   *
   * THIS PROP IS A NON-DOCUMENTED PROP, AND IS ONLY TO BE USED FOR INTERNAL DEVELOPMENT.
   */
  __chakraIsRaw: Boolean
};
function ___chakra___(tag, options = {}) {
  const inputHandlers = formElements[typeof tag === "string" ? tag : ""];
  const _props = inputHandlers && inputHandlers.props || {};
  const handleValueChange = inputHandlers && inputHandlers.handleValueChange;
  return defineComponent({
    name: `chakra-factory-${String(tag)}`,
    inheritAttrs: false,
    props: {
      ...chakraProps,
      ..._props
    },
    setup(props, {
      slots,
      emit,
      attrs
    }) {
      const {
        theme,
        colorMode,
        forced
      } = useChakra();
      const layerStyle$ = computed(() => props.layerStyle || (options == null ? void 0 : options.layerStyle));
      const textStyle$ = computed(() => props.textStyle || (options == null ? void 0 : options.textStyle));
      const baseStyle$ = computed(() => props.baseStyle || (options == null ? void 0 : options.baseStyle));
      const noOfLines$ = computed(() => props.noOfLines || (options == null ? void 0 : options.noOfLines));
      const isTruncated$ = computed(() => props.isTruncated || (options == null ? void 0 : options.isTruncated));
      const __css$ = computed(() => props.__css || (options == null ? void 0 : options.__css));
      const css$ = computed(() => props.css || (options == null ? void 0 : options.css));
      const sx$ = computed(() => props.sx || (options == null ? void 0 : options.sx));
      const apply$ = computed(() => props.apply || (options == null ? void 0 : options.apply));
      return () => {
        const {
          class: inheritedClass,
          __label,
          ...rest
        } = attrs;
        const {
          layerStyle,
          baseStyle,
          textStyle,
          noOfLines,
          isTruncated,
          __css,
          css: css3,
          sx,
          apply,
          label,
          ...otherStyles
        } = options;
        const {
          styles,
          attrs: elementAttributes
        } = extractStyleAttrs({
          ...otherStyles,
          // Prioritize user provided styles
          ...rest
        });
        const resolvedComponentStyles = resolveStyles({
          __css: __css$.value,
          baseStyle: baseStyle$.value,
          apply: apply$.value,
          layerStyle: layerStyle$.value,
          noOfLines: noOfLines$.value,
          isTruncated: isTruncated$.value,
          textStyle: textStyle$.value,
          sx: sx$.value,
          css: css$.value,
          ...styles,
          theme
        });
        const componentLabel = label || __label;
        const _componentName = componentLabel ? `chakra-${componentLabel}` : "";
        const className = css(resolvedComponentStyles);
        let componentOrTag = props.as || tag;
        if (!isObject(componentOrTag) && !domElements.includes(componentOrTag)) {
          componentOrTag = resolveComponent(componentOrTag);
        }
        const Tag = componentOrTag || props.as;
        return _createVNode(Tag, _mergeProps({
          "class": cx(inheritedClass, _componentName, className)
        }, elementAttributes, {
          "data-theme": forced ? colorMode.value : void 0
        }, !props.__chakraIsRaw && handleValueChange && // @ts-ignore
        handleValueChange(props, attrs.type)(emit)), _isSlot(slots) ? slots : {
          default: () => [slots]
        });
      };
    }
  });
}
__name(___chakra___, "___chakra___");
var chakra = Object.assign(___chakra___, domElements.reduce((acc, curr) => {
  acc[curr] = ___chakra___(curr);
  return acc;
}, {}));
var toCSSObject = /* @__PURE__ */ __name((options) => (props) => {
  const {
    theme,
    css: cssProp,
    __css,
    sx,
    ...rest
  } = props;
  const styleProps = objectFilter(rest, (_, prop) => isStyleProp(prop));
  const finalStyles = resolveStyles(Object.assign(options, {
    theme
  }, styleProps));
  const computedCSS = css2(finalStyles)(props.theme);
  return cssProp ? [computedCSS, cssProp] : computedCSS;
}, "toCSSObject");
function styled(component, options) {
  const {
    baseStyle,
    ...styledOptions
  } = options != null ? options : {};
  const styleObject = toCSSObject(options);
  return chakra(component, styledOptions);
}
__name(styled, "styled");
var _chakra = styled;
var resolveStyles = /* @__PURE__ */ __name((resolvers = {}) => {
  const {
    layerStyle,
    baseStyle,
    textStyle,
    noOfLines,
    isTruncated,
    __css,
    css: cssProp,
    sx,
    apply,
    theme,
    ...otherStyles
  } = resolvers;
  const _layerStyle = get(theme, `layerStyles.${layerStyle}`, {});
  const _textStyle = get(theme, `textStyles.${textStyle}`, {});
  let truncateStyle = {};
  if (noOfLines != null) {
    truncateStyle = {
      overflow: "hidden",
      textOverflow: "ellipsis",
      display: "-webkit-box",
      WebkitBoxOrient: "vertical",
      WebkitLineClamp: noOfLines
    };
  } else if (isTruncated) {
    truncateStyle = {
      overflow: "hidden",
      textOverflow: "ellipsis",
      whiteSpace: "nowrap"
    };
  }
  const finalStyles = css2(Object.assign({}, __css, baseStyle, {
    apply
  }, _layerStyle, _textStyle, truncateStyle, otherStyles, sx))(theme);
  const cssObject = Object.assign(finalStyles, isFunction(cssProp) ? cssProp(theme) : cssProp);
  return cssObject;
}, "resolveStyles");
domElements.forEach((tag) => {
  _chakra[tag] = _chakra(tag);
});

export {
  ___chakra___,
  chakra,
  toCSSObject,
  styled,
  _chakra,
  resolveStyles
};
