import * as vue from 'vue';
import { ThemeOverride } from '@chakra-ui/theme-utils';
import { WithCSSVar } from '@chakra-ui/styled-system';

/** Provides theme object in component context */
declare const useTheme: <T extends WithCSSVar<ThemeOverride> = WithCSSVar<ThemeOverride>>() => T;
/** Single hook to provide theme and color mode values */
declare const useChakra: () => {
    theme: WithCSSVar<ThemeOverride>;
    colorMode: vue.ComputedRef<"dark" | "light">;
    forced: boolean | undefined;
};

export { useChakra, useTheme };
