"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/composables/use-style-config.ts
var use_style_config_exports = {};
__export(use_style_config_exports, {
  useMultiStyleConfig: () => useMultiStyleConfig,
  useStyleConfig: () => useStyleConfig
});
module.exports = __toCommonJS(use_style_config_exports);
var import_vue2 = require("vue");
var import_utils = require("@chakra-ui/utils");

// src/composables/use-chakra.ts
var import_vue = require("vue");
var import_c_color_mode = require("@chakra-ui/c-color-mode");
var useTheme = /* @__PURE__ */ __name(() => {
  const theme = (0, import_vue.inject)("$chakraTheme");
  return theme;
}, "useTheme");
var useChakra = /* @__PURE__ */ __name(() => {
  const theme = useTheme();
  const {
    colorMode,
    forced
  } = (0, import_c_color_mode.useColorMode)();
  return {
    theme,
    colorMode,
    forced
  };
}, "useChakra");

// src/composables/use-style-config.ts
function useStyleConfig(themeKey, themingProps, options = {}) {
  return (0, import_vue2.computed)(() => {
    var _a, _b, _c, _d, _e, _f, _g;
    const {
      styleConfig: styleConfigProp,
      ...rest
    } = themingProps.value || themingProps;
    const {
      theme,
      colorMode
    } = useChakra();
    const themeStyleConfig = (0, import_utils.get)(theme, `components.${themeKey}`);
    const styleConfig = styleConfigProp || themeStyleConfig;
    const mergedProps = (0, import_utils.mergeWith)({
      theme,
      colorMode: colorMode.value
    }, (_a = styleConfig == null ? void 0 : styleConfig.defaultProps) != null ? _a : {}, (0, import_utils.filterUndefined)(rest));
    const baseStyles = (0, import_utils.runIfFn)((_b = styleConfig == null ? void 0 : styleConfig.baseStyle) != null ? _b : {}, mergedProps);
    const variants = (0, import_utils.runIfFn)((_d = (_c = styleConfig == null ? void 0 : styleConfig.variants) == null ? void 0 : _c[mergedProps.variant]) != null ? _d : {}, mergedProps);
    const sizes = (0, import_utils.runIfFn)((_f = (_e = styleConfig == null ? void 0 : styleConfig.sizes) == null ? void 0 : _e[mergedProps.size]) != null ? _f : {}, mergedProps);
    const styles = (0, import_utils.mergeWith)({}, baseStyles, sizes, variants);
    if (options.isMultiPart && (styleConfig == null ? void 0 : styleConfig.parts)) {
      (_g = styleConfig == null ? void 0 : styleConfig.parts) == null ? void 0 : _g.forEach((part) => {
        var _a2;
        styles[part] = (_a2 = styles[part]) != null ? _a2 : {};
      });
    }
    return styles;
  });
}
__name(useStyleConfig, "useStyleConfig");
function useMultiStyleConfig(themeKey, themingProps) {
  return useStyleConfig(themeKey, themingProps, {
    isMultiPart: true
  });
}
__name(useMultiStyleConfig, "useMultiStyleConfig");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useMultiStyleConfig,
  useStyleConfig
});
