import { Dict } from '@chakra-ui/utils';
import { SystemStyleObject } from '@chakra-ui/styled-system';
import { ComputedRef } from 'vue';

declare const StylesProvider: (opts: ComputedRef<Dict<SystemStyleObject>>) => void;
declare const useStyles: (fallback?: ComputedRef<Dict<SystemStyleObject>> | undefined) => ComputedRef<Dict<SystemStyleObject>>;

declare const createStylesContext: <AnatomyParts extends readonly string[]>(componentName: string) => [(opts: ComputedRef<{ [K in AnatomyParts[number]]: SystemStyleObject; }>) => void, (fallback?: ComputedRef<{ [K in AnatomyParts[number]]: SystemStyleObject; }> | undefined) => ComputedRef<{ [K in AnatomyParts[number]]: SystemStyleObject; }>, Symbol];

export { StylesProvider, createStylesContext, useStyles };
